﻿commonModule.controller('importCitSalaryAdvanceCon', ['$scope', '$log', '$translate', '$timeout', '$q'
    , 'apiInterceptor', 'Upload', 'citImportDataService', 'SweetAlert', 'vatSessionService', 'enums',
    'vatOperationLogService','templateService','orgService',
    function ($scope, $log, $translate, $timeout, $q, apiInterceptor, Upload, citImportDataService, SweetAlert
        , vatSessionService, enums, vatOperationLogService, templateService, orgService) {
        'use strict';
        // $anchorScroll.yOffset=55;
        // $location.hash('top');
        // $anchorScroll.yOffset=55;
        // $anchorScroll();
        var uploadUrl = apiInterceptor.webApiHostUrl + '/citImport/citImportExcel';
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        $scope.period = $scope.periodId;
        $scope.moduleid = enums.vatModuleEnum.Import_TrialBalance;
        $scope.chunkSize = 100000;
        $scope.success = false;
        $scope.isSelectPeriod = true;
        $scope.isShowImportTotalBtn = true;
        $scope.projectID = vatSessionService.project.id;
        $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 }; //导入方式
        $scope.showTotalSecondRow = false;

        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth();
        $scope.selectedDate = new Date(vatSessionService.year, vatSessionService.month - 1, 1);
        $scope.startDate = new Date(year - 20, 1, 1);
        $scope.endDate = new Date(year + 20, 1, 1);
        $scope.viewMode = 2;
        $scope.dateFormat = $translate.instant('dateFormat4Year');

        $scope.importExcelFile = null;
        $scope.UploadPeriodTime = null;

        $scope.companyList = [];
        $scope.checkedCompanyList = [];
        $scope.checkedCompanyCodeList = [];
        $scope.checkedCompanyTypeList = "";
        $scope.maxTitleLength = constant.maxButtonTitleLength;

        $scope.month = 0;

        //税会差异选项内容
        $scope.applyFilterTypes = [{
            key: "0",
            name: $translate.instant('EndOfThisYear')
        }, {
            key: "1",
            name: $translate.instant('BeginOfNextYear')
        }];
        //初始化税会差异选项
        $scope.endBeginOptions = {
            items: $scope.applyFilterTypes,
            value: $scope.applyFilterTypes[0].key,
            valueExpr: "key",
            displayExpr: "name",
            onValueChanged: function (data) {

                $scope.month = data.value;

            }
        };

        //写日志
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('JournalAdjustImport'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period,
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[1], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[1].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };


        $scope.totalData = {
            totalNumber: 0,
            begDebitTotal: 0,
            begCreditTotal: 0,
            endDebitTotal: 0,
            endCreditTotal: 0,
            begBalTotal: 0,
            endBalTotal: 0,
            debitTotal: 0,
            creditTotal: 0,
        };

        //分页获取数据
        $scope.eventService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
            }
        };

        //导入事件
        var importFile = function (importType) {


            var impExl = $scope.importExcelFile;
            var deferred = $q.defer();
            var token = $('input[name="__RequestVerificationToken"]').val();


            if (!impExl) {
                SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
                return;
            }

            //列名对应验证
            /*if (validationColumnMapping()) {
                //数据类型验证
                validationTbData().then(function (isSuccess) {
                    if (isSuccess) {

                });
            }*/
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            } else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            } else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }

            var period = $scope.UploadPeriodTime;
            if(period == null){
                SweetAlert.warning($translate.instant('PleaseSelectPeriod'));
                return;
            }
            if($scope.checkedCompanyCodeList.length == 0){
                SweetAlert.warning($translate.instant('PleaseSelectOrganization'));
                return;
            }
            var orgIds = JSON.stringify($scope.checkedCompanyCodeList);
            //控制背景阴影的出现
            $('#busy-indicator-container').show();
            Upload.upload({
                url: uploadUrl,
                data: {
                    orgIds : orgIds,
                    periodDate : period,
                    importType : importType,
                    importFileType : constant.citImportFileType.SalaryAdvance,
                    month: $scope.month
                },
                file: impExl,
                headers: {
                    'Access-Control-Allow-Origin': '*',
                    Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                    __RequestVerificationToken: token,
                    withCredentials: true
                },
                __RequestVerificationToken: token,
                withCredentials: true
            }).then(function(data) {
                    var resp = data.data;
                    $('#busy-indicator-container').hide();
                    deferred.resolve();
                    if (resp.result) {
                        logDto.UpdateState = $translate.instant('ImportSuccess')+"  "+resp.data + $translate.instant('ItemData');
                        vatOperationLogService.addOperationLog(logDto);
                        SweetAlert.success($translate.instant('ImportSuccess')+"  "+resp.data + $translate.instant('ItemData'));
                    } else {

                        if (resp.resultMsg && resp.resultMsg.length > 0) {
                            SweetAlert.warning(resp.resultMsg);
                        }else{
                            SweetAlert.error($translate.instant('ImportFailed'));
                        }
                        logDto.UpdateState = $translate.instant('ImportFail');
                        vatOperationLogService.addOperationLog(logDto);
                    }
                    getImportLog();

                }
                // , function(resp) {
                //     deferred.resolve();
                //     if (resp.statusText === 'HttpRequestValidationException') {
                //         SweetAlert.warning($translate.instant('HttpRequestValidationException'));
                //     } else {
                //         SweetAlert.warning('SaveFail');
                //     }
                //     logDto.UpdateState = $translate.instant('ImportFail');
                //     vatOperationLogService.addOperationLog(logDto);
                //     SweetAlert.error($translate.instant('ImportFail'));
                //     console.log('Error status: ' + resp.status);
                // }, function(evt) {
                //     deferred.resolve();
                //     var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                //     $log.debug('progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
                // }
            );
        };

        var getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };

        var loadImportInfoDataGrid = function () {

            $scope.importPLStatusGridOptions = {
                bindingOptions: {
                    dataSource: 'citImportLogGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "id",
                    visible: false,
                    allowHeaderFiltering: false,
                    caption: $translate.instant('id')
                }, {
                    dataField: "taxpayerIdNum",
                    width: '15%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('TaxpayerIdNum')
                }, {
                    dataField: "companyCode",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyCode'),
                    width: '15%'
                }, {
                    dataField: "companyName",
                    allowHeaderFiltering: false,
                    width: '27%',
                    caption: $translate.instant('CompanyName')
                }, {
                    dataField: "period",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('Period')
                }, {
                    dataField: "createTimeStr",
                    allowHeaderFiltering: false,
                    width: '10%',
                    caption: $translate.instant('createTime')
                }, {
                    dataField: "recordSize",
                    allowHeaderFiltering: false,
                    width: '8%',
                    caption: $translate.instant('RecordSize')
                }, {
                    dataField: "errorMsg",
                    allowHeaderFiltering: false,
                    width: '20%',
                    caption: $translate.instant('Status')
                }
                ],
                onContentReady: function (e) {
                    $scope.accountingRateListInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };
            getImportLog();
        };

        var getImportLog = function () {

            citImportDataService.getCitDataImportLog(constant.citImportFileType.SalaryAdvance).success(function (data) {
                if (data) {
                    $scope.citImportLogGridSource = data.data;
                    for (var i = 1; i <= $scope.citImportLogGridSource.length; i++) {
                        $scope.citImportLogGridSource[i - 1].index = i;
                    }
                }
            });
        };

        var initImportLogFromDB = function () {
            getImportLog();
        };

        //加载文档后操作
        var initImportFile = function (fileName) {
            var arr = fileName.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.fileName = fileName.name;
            //初始化数据
            $scope.selectedMappingList = [];
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;
        }

        //日志
        var showOperateLogPop = function () {
            $scope.isShowLog = true;
        };

        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };

        // 检查用户机构权限
        var checkUserOrganizationPermissionList = function () {

            var list = [];

            var userManageTemp = constant.vatPermission.dataImport.balanceSheet;
            list.push(userManageTemp.importCode);
            $scope.hasImportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasImportPermission = data[userManageTemp.importCode];
            });
        };

        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.balanceSheet.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };

        var setButtonWrapStyle = function () {
            if ($scope.fileName) {
                return { width: "100%" };
            }
        };

        var setGridStyle = function () {
            if ($scope.showTotalSecondRow) {
                return { 'margin-top': '60px' }
            }
            else {
                return { 'margin-top': '55px' }
            }
        };

        var initDatePicker = function () {
            var ele1 = $("#periodDatepicker");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: $scope.dateFormat //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.selectedDate);
        };

        var initCompanyList = function () {
            orgService.getOrgListByUserId().success(function (data) {
                if (data) {
                    $scope.companyList = data;
                }
            });
        };

        $scope.selectOne = function () {
            $scope.checkedCompanyList = [];
            angular.forEach($scope.companyList , function (i) {
                var index = $scope.checkedCompanyList.indexOf(i.id);
                if(i.checked && index === -1) {
                    $scope.checkedCompanyList.push(i);
                } else if (!i.checked && index !== -1){
                    $scope.checkedCompanyList.splice(index, 1);
                }
            });

            $scope.selectedAll = $scope.companyList.length === $scope.checkedCompanyList.length;

            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name+";";
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.selectAll = function () {
            if($scope.selectedAll) {
                $scope.selectedOne = true;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    $scope.checkedCompanyList.push(i);
                    i.checked = true;
                })
            }else {
                $scope.selectedOne = false;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    i.checked = false;
                })
            }
            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name;
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.downloadTemplate = function () {

            templateService.citDownloadTemplate(constant.citImportFileType.SalaryAdvance).success(function (data, status, headers) {
                var octetStreamMime = 'application/octet-stream';
                var contentType = headers('content-type') || octetStreamMime;
                if (window.navigator.msSaveBlob) {
                    var blob = new Blob([data], {
                        type: contentType
                    });
                    navigator.msSaveBlob(blob, "AdjustmentTable");
                } else {
                    var urlCreator = window.URL || window.webkitURL || window.mozURL || window.msURL;
                    if (urlCreator) {
                        var a = document.createElement('a');
                        var blob = new Blob([data], {
                            type: contentType
                        });
                        var url = urlCreator.createObjectURL(blob);
                        a.href = url;
                        a.target = '_blank';
                        a.download = "SalaryAdvance.xlsx";
                        document.body.appendChild(a);
                        a.click();
                    }
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };

        //开始
        (function initialize() {

            $log.debug('ImportTBController.ctor()...');
            checkUserOrganizationPermissionList();
            $scope.importFile = importFile;
            $scope.initPagingControl = initPagingControl;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            $scope.getGridHeight = getGridHeight;
            $scope.showOperateLogPop = showOperateLogPop;

            $scope.setGridStyle = setGridStyle;

            getUserPermission();
            initCompanyList();

            loadImportInfoDataGrid();
            initDatePicker();

            $scope.$watch('importExcelFile', function (newValue, oldValue) {
                if (newValue !== null && newValue !== oldValue) {
                    initImportFile(newValue);
                }
            });

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        })();
    }
]);